# HS2024 - Seminar Cryptocurrencies and Smart Contracts

Please see the [ILIAS module](https://ilias.unibe.ch/goto.php?target=crs_3102234) of the seminar for all other information.

## List of Layer-1 Projects

| Blockchain | Organization and Network | Documentation | Testnets | Smart-contract Programming |
| ------ | ------ | ------ |  ------ | ------ |
|  Ethereum (ETH)  |  [Ethereum Foundation](https://ethereum.org/)  |  [Whitepaper](https://ethereum.org/en/whitepaper/);  [Consensus Evolution Blog](https://github.com/ethereum/pos-evolution/blob/master/pos-evolution.md)  |  [List of Testnets](https://www.alchemy.com/list-of/testnets-on-ethereum); [Another list](https://moralis.io/ethereum-testnet-full-ethereum-test-network-guide/)  |  [Tutorial](https://www.web3.university/tracks/create-a-smart-contract/deploy-your-first-smart-contract); [Hardhat development environment](https://hardhat.org)  |
|  <del>Binance Smartchain (BNB)</del>  |  [BNBChain](https://www.bnbchain.org/en)  |  [Whitepaper](https://github.com/bnb-chain/whitepaper/blob/master/WHITEPAPER.md); [Docs](https://docs.bnbchain.org/bnb-smart-chain/)  |  TBD  |  TBD  |
|  <del>Solana (SOL)</del>  |  [Solana](https://solana.com)  |  [Whitepaper](https://solana.com/solana-whitepaper.pdf); [Docs](https://solana.com/docs); [Analysis paper](https://doi.org/10.1145/3631461.3631553)  |  TBD  |  TBD  |
|  XRP Ledger (XRP)  |  [Ripple](https://ripple.com); [XRP Ledger](https://xrpl.org)  |  [Consensus docs](https://xrpl.org/docs/concepts/consensus-protocol); [Analysis paper](https://doi.org/10.4230/LIPIcs.OPODIS.2020.10)  |    [Testnets](https://xrpl.org/resources/dev-tools/xrp-faucets/)    |    [Hooks](https://xrpl-hooks.readme.io/docs/introduction)    |
|  Cardano (ADA)  |  [Input-Output](https://iohk.io); [Cardano Foundation](https://cardanofoundation.org/); [Cardano Ecosystem](https://cardano.org/)  |  [Protocol docs](https://docs.cardano.org/about-cardano/new-to-cardano/proof-of-stake/); [Papers](https://docs.cardano.org/about-cardano/explore-more/relevant-research-papers/)  |  [Testnets](https://docs.cardano.org/cardano-testnets/getting-started/)  |  [Introduction](https://developers.cardano.org/docs/smart-contracts/)  |
|  Avalanche (AVAX)  |  [Ava Labs](https://www.avalabs.org); [AVAX Network](https://www.avax.network/)  |  [Protocol docs](https://docs.avax.network/learn/avalanche-consensus);  [Analysis paper](https://arxiv.org/abs/2401.02811)  |  [Fuji Testnet](https://docs.avax.network/build/subnet/deploy/fuji-testnet-subnet)  |  [Tutorial](https://docs.avax.network/build/dapp/smart-contracts/remix-deploy)  |
|  Polkadot (DOT)  |  [Web3 Foundation](https://web3.foundation); [Polkadot](https://polkadot.network/)  |  [Lightpaper](https://assets.polkadot.network/Polkadot-lightpaper.pdf);  [Protocol docs](https://wiki.polkadot.network/docs/learn-index)  |  [Testnets](https://wiki.polkadot.network/docs/maintain-networks)  |  [Tutorial](https://wiki.polkadot.network/docs/build-smart-contracts)   |
|  Internet Computer (ICP)  |  [DFINITY](https://dfinity.org/);  [Internet Computer](https://internetcomputer.org)  |  [Whitepaper](https://internetcomputer.org/whitepaper.pdf); [Docs](https://internetcomputer.org/docs/current/home)  |  [Local Testnet](https://internetcomputer.org/docs/current/developer-docs/getting-started/deploy/local)  |  [Developer docs](https://internetcomputer.org/docs/current/home)  |
|  Stellar (XLM)  |  [Stellar](https://stellar.org/)  |  [Whitepaper (see PDF inside)](https://stellar.org/learn/stellar-consensus-protocol); [Consensus docs](https://developers.stellar.org/docs/learn/fundamentals/stellar-consensus-protocol)  |  [Testnet](https://developers.stellar.org/docs/learn/fundamentals/networks)  |  [Soroban](https://stellar.org/soroban); [Docs](https://stellar.org/learn/smart-contract-basics)  |
|  Filecoin (FIL)  |  [Protocol Labs](https://protocol.ai); [Filecoin](https://filecoin.io/)  |  [Whitepaper](https://filecoin.io/filecoin.pdf);  [Protocol docs](https://docs.filecoin.io/);  [Consensus docs](https://docs.filecoin.io/basics/interplanetary-consensus)  |  [Testnet](https://docs.filecoin.io/basics/what-is-filecoin/networks)  |  [Developer docs](https://fvm.filecoin.io/)  |
|  Cosmos (ATOM)  |  [Interchain Foundation](https://interchain.io/technology); [Cosmos](https://cosmos.network)  |  [Cosmos introduction](https://tutorials.cosmos.network/academy/1-what-is-cosmos/); [Tendermint/CometBFT](https://docs.cometbft.com/); [IBC](https://arxiv.org/pdf/2006.15918); [Whitepaper (outdated)](https://github.com/cosmos/cosmos/blob/master/WHITEPAPER.md); [Apps](https://tutorials.cosmos.network/academy/2-cosmos-concepts/1-architecture.html)  |  [App Testnet](https://docs.cosmos.network/v0.50/build/building-apps/app-testnet)  |  [ABCI](https://docs.cosmos.network/v0.50/build/abci/introduction) | 


## List of Layer-2 Projects

| Layer-2 Project | Organization and Network | Documentation | Testnets | Programming |
| ------ | ------ | ------ | ------ | ------ |
|  Arbitrum (ARB)  |  [Offchain Labs](https://www.offchainlabs.com); [Arbitrum](https://arbitrum.io/)  |  [Academic Paper](https://www.usenix.org/system/files/conference/usenixsecurity18/sec18-kalodner.pdf);  [Whitepaper](https://docs.arbitrum.io/how-arbitrum-works/inside-arbitrum-nitro); [Docs](https://docs.arbitrum.io/)  |  [Local Testnet](https://docs.arbitrum.io/stylus/reference/testnet-information)  |   [Tutorial](https://docs.arbitrum.io/build-decentralized-apps/quickstart-solidity-hardhat)  |
|  <del>Optimism (OP)</del>  |  [Optimism](https://www.optimism.io)  |  [Specs](https://specs.optimism.io); [Docs](https://docs.optimism.io)  |  [Create testnet](https://docs.optimism.io/builders/chain-operators/tutorials/create-l2-rollup)  |  [OP Stack](https://docs.optimism.io/stack/getting-started)  |
|  Starknet (STRK)  |  [Starkware](https://starkware.co/stark/); [Starknet](https://www.starknet.io)  |  [Book](https://book.starknet.io/title-page.html); [Docs](https://docs.starknet.io)  |  [Tutorial](https://book.starknet.io/ch01-00-getting-started.html)  |  [Cairo language](https://starkware.co/cairo/)  |
|  ZkSync (ZK)  |  [Matter Labs](https://matter-labs.io); [ZkSync](https://zksync.io/)  |  [Docs](https://docs.zksync.io); [Quickstart](https://docs.zksync.io/build/)  |  [Testnets](https://docs.zksync.io/ecosystem/network-faucets)  |  [Tutorial](https://docs.zksync.io/build/start-coding/quick-start)  |


## Further Projects (Oracle, Layer 3, Decentralized Finance)

| Project | Type | Organization and Network | Documentation | Testnets | Programming |
| ------ | ------ | ------ | ------ | ------ | ------ |
|  Chainlink (LINK) | Oracle Network (Data feeds & CCIP) |  [Chainlink Labs](https://chainlinklabs.com); [Chainlink](https://chain.link/)  |  [Whitepaper](https://research.chain.link/whitepaper-v1.pdf); [Whitepaper 2.0](https://chain.link/whitepaper); [Off-chain Reporting](https://docs.chain.link/architecture-overview/off-chain-reporting); [Data Feeds](https://docs.chain.link/data-feeds); [CCIP](https://docs.chain.link/ccip)  |  [Developer docs](https://docs.chain.link/getting-started/conceptual-overview);  [Tutoarial](https://github.com/smartcontractkit/hardhat-starter-kit)  |  [Consuming data feeds](https://docs.chain.link/data-feeds/getting-started); [Sending data with CCIP](https://docs.chain.link/ccip/getting-started) * |
|  Celestia (TIA)  |  Data Availability Layer  |  [Celestia](https://celestia.org)  |  [Whitepaper](https://arxiv.org/abs/1905.09274); [Fraud proofs and DA proofs](https://arxiv.org/abs/1809.09044); [Run a light node](https://docs.celestia.org/nodes/light-node)  |  [Run a light node](https://celestia.org/run-a-light-node/)  |  Not possible*  |
|  <del>EigenLayer (future: EIGEN)</del>  |  Restaking, esp. Data Availability  |  [EigenLayer](https://www.eigenlayer.xyz/)  |  [Whitepapers](https://docs.eigenlayer.xyz/eigenlayer/overview/whitepaper); [Docs](https://docs.eigenlayer.xyz)  |  [Local Testnet](https://medium.com/@ilaNihas/eigenlayer-a-step-by-step-guide-to-testnet-node-setup-e242f4e35344)  |  Not possible*  |

*Note: Some of the networks cannot be programmed. Possible projects for those networks will be discussed with the teachers (for example: demonstrate a core functionality).

## Additional Information

### Recommended podcasts

| Podcast | Title | Topic |
| ------- | ----- | ----- |
| [ZK 244](https://zeroknowledge.fm/244-2) | Journey to Blockchain with David Tse | Consensus, Ethereum, David Tse |
| [ZK 295](https://zeroknowledge.fm/295-2) | Return to MPC with Nigel Smart | Advanced Cryptography, multi-party computation |
